
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <unistd.h>
#include <stdio.h>

int main(int argc, char *argv[])
{
    unlink("test.lock");
    
    printf("Open file. Result: ");
    int fd = open("test.lock", O_WRONLY|O_CREAT, 0666);
    printf("%i\n", fd);
    
    printf("Locking file. Result: ");
    struct flock lock_data;
    lock_data.l_type = F_WRLCK;
    lock_data.l_whence = SEEK_SET;
    lock_data.l_start = 0;
    lock_data.l_len = 1;
    int result = fcntl(fd, F_SETLK, &lock_data);
    printf("%i\n", result);
    
    printf("Unlink file. Result: ");
    // following call fails, when executing in a shared folder:
    result = unlink("test.lock");
    printf("%i\n", result);
    
    if (result == -1)
    {
        printf("Test failed\n");
        close(fd);
        unlink("test.lock");
        return -1;
    }
    
    printf("Close file. Result: ");
    result = close(fd);
    printf("%i\n", result);
    
    printf("Test passed.\n");
    
    return 0;
}
